﻿namespace UltraMonthViewMultiYearButton
{
    using System.Drawing;
    using System.Windows.Forms;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinSchedule.MonthViewMulti;

    public class MyDraw : IUIElementDrawFilter
    {
        private Font font;

        public MyDraw(Font font)
            : base()
        {
            this.font = font;
        }

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            MonthScrollButtonUIElement scroll = drawParams.Element as MonthScrollButtonUIElement;

            if (scroll != null)
            {
                if (scroll.ButtonState == UIElementButtonState.MouseOver)
                {
                    drawParams.AppearanceData.BackColor = SystemColors.ControlLight;
                }

                if (scroll.ButtonState == UIElementButtonState.MouseDownAndOver)
                {
                    drawParams.AppearanceData.BackColor = SystemColors.ControlDark;
                }

                Rectangle rect = scroll.Rect;
                ScrollButton scrollButton = (ScrollButton)scroll.GetContext(typeof(ScrollButton), true);

                drawParams.DrawBackColor(rect);

                if (scrollButton == ScrollButton.Left)
                {
                    drawParams.Graphics.DrawString("L", this.font, Brushes.Black, rect);
                }
                else if (scrollButton == ScrollButton.Right)
                {
                    drawParams.Graphics.DrawString("R", this.font, Brushes.Black, rect);
                }

                return true;
            }

            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is MonthScrollButtonUIElement)
            {
                return DrawPhase.BeforeDrawElement;
            }

            return DrawPhase.None;
        }
    }
}
